%global namedversion %{version}%{?namedreltag}

Name:           logback
Version:        1.0.13
Release:        4%{?reltag}%{?dist}
Epoch:          0
Summary:        Logback
License:        EPL 1.0/LGPLv2+
Group:          Development/Java
URL:            http://logback.qos.ch
%if 0
rm -rf logback-1.0.13.tar.xz logback/ .gitignore
/usr/bin/git clone -q -n git://github.com/qos-ch/logback.git
cd logback/
/usr/bin/git archive --prefix=logback-1.0.13/ v_1.0.13 | /usr/bin/xz -9 > ../logback-1.0.13.tar.xz
cd ../
/usr/bin/rhpkg new-sources logback-1.0.13.tar.xz
/usr/bin/rhpkg prep
%endif
Source0:        logback-1.0.13.tar.xz
Source1:        slf4j.tar.xz
Patch0:         0000-logback-pom.patch
Patch1:         0001-subethasmtp.patch
Patch2:         0002-felix-framework-string-map.patch
Patch3:         0003-integration-no-haltonfailure.patch
#
Requires:       logback-access = %{epoch}:%{version}-%{release}
Requires:       logback-classic = %{epoch}:%{version}-%{release}
Requires:       logback-core = %{epoch}:%{version}-%{release}
Requires:       logback-examples = %{epoch}:%{version}-%{release}
Requires:       logback-parent = %{epoch}:%{version}-%{release}
Requires:       logback-site = %{epoch}:%{version}-%{release}
#
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
#
BuildRequires:  maven-jxr-plugin >= 0:2.3
#
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-default-skin
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-install-plugin
BuildRequires:  maven-jar-plugin
BuildRequires:  maven-javadoc-plugin
BuildRequires:  maven-project-info-reports-plugin
BuildRequires:  maven-remote-resources-plugin
BuildRequires:  maven-resources-plugin
BuildRequires:  maven-site-plugin
BuildRequires:  maven-source-plugin
BuildRequires:  maven-surefire-plugin
BuildRequires:  surefire-junit4
%if 0
geronimo-j2ee-1.4-apis         noarch 1.2-13.2.1.ep5.el5           build 934 k
geronimo-jta                   noarch 1.1.1-17.el7                 build  19 k
^^^^ FIXME: this package installs bad fragments and overrides us with Provides: jta = 1.1.1-17.el7 (> jta = 0:1.1)
geronimo-specs-poms            noarch 1.2-13.2.1.ep5.el5           build  20 k
%endif
BuildRequires:  geronimo-jta-1.1-api >= 0:1.2-13.2.1
BuildArch:      noarch
BuildRoot:      %{_tmppath}/logback-%{namedversion}-%{release}-root

%description
%{summary}.

%package -n logback-parent
Summary:        Logback-Parent
Group:          Development/Java
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
BuildRequires:  junit >= 0:4.10
BuildRequires:  fest-assert >= 0:1.2
BuildRequires:  wagon-ssh >= 0:2.0
BuildRequires:  maven-compiler-plugin >= 0:2.3.2
BuildRequires:  maven-surefire-plugin >= 0:2.14.1
BuildRequires:  maven-source-plugin >= 0:2.1.2
BuildRequires:  maven-jar-plugin >= 0:2.3.1
BuildRequires:  maven-eclipse-plugin >= 0:2.8
BuildRequires:  maven-assembly-plugin >= 0:2.1
BuildRequires:  maven-bundle-plugin >= 0:2.1.0
BuildRequires:  findbugs-maven-plugin >= 0:2.5
# XXX: 3.0
BuildRequires:  maven-site-plugin >= 0:2.4

%description -n logback-parent
logback project pom.xml file.

%package -n logback-core
Summary:        Logback Core Module
Group:          Development/Java
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
Requires:       logback-parent = %{epoch}:%{version}-%{release}
BuildRequires:  janino >= 0:2.6.1
BuildRequires:  jansi >= 0:1.9
# FIXME: mail >= 0:1.4
BuildRequires:  glassfish-javamail >= 0:1.4
BuildRequires:  jboss-jms-api_1.1_spec >= 0:1.0.1
BuildRequires:  mockito-core >= 0:1.9.0
BuildRequires:  jboss-servlet-api_2.5_spec >= 0:1.0.1
BuildRequires:  maven-surefire-plugin >= 0:2.14.1
BuildRequires:  maven-jar-plugin >= 0:2.3.1
BuildRequires:  maven-bundle-plugin

%description -n logback-core
logback-core module.

%package -n logback-classic
Summary:        Logback Classic Module
Group:          Development/Java
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
Requires:       logback-parent = %{epoch}:%{version}-%{release}
Requires:       logback-core = %{epoch}:%{version}-%{release}
Requires:       slf4j-api >= 0:1.7.5
BuildRequires:  slf4j-api >= 0:1.7.5
BuildRequires:  slf4j-ext >= 0:1.7.5
# FIXME: slf4j-api-tests-1.7.5
BuildRequires:  slf4j-api >= 0:1.7.5
BuildRequires:  log4j-over-slf4j >= 0:1.7.5
BuildRequires:  jul-to-slf4j >= 0:1.7.5
BuildRequires:  dom4j >= 0:1.6.1
BuildRequires:  hsqldb >= 0:1.8.0.7
# FIXME: h2
BuildRequires:  h2database >= 0:1.2.132
BuildRequires:  postgresql-jdbc >= 0:8.4.703
BuildRequires:  mysql-connector-java >= 0:5.1.9
# FIXME: mail >= 0:1.4
BuildRequires:  glassfish-javamail >= 0:1.4
BuildRequires:  janino >= 0:2.6.1
# FIXME: groovy-all >= 0:2.0.7
BuildRequires:  groovy20
BuildRequires:  slf4j-integration >= 0:1.7.5
BuildRequires:  jboss-jms-api_1.1_spec >= 0:1.0.1
BuildRequires:  jboss-servlet-api_2.5_spec >= 0:1.0.1
BuildRequires:  greenmail >= 0:1.3
BuildRequires:  subethasmtp >= 0:2.1.0
BuildRequires:  org.apache.felix.main >= 0:2.0.2
BuildRequires:  gmaven-plugin >= 0:1.5
BuildRequires:  gmaven-runtime-2.0 >= 0:1.5
BuildRequires:  maven-jar-plugin >= 0:2.3.1
BuildRequires:  maven-antrun-plugin >= 0:1.4
BuildRequires:  maven-surefire-plugin >= 0:2.14.1
BuildRequires:  maven-bundle-plugin

%description -n logback-classic
logback-classic module.

%package -n logback-access
Summary:        Logback Access Module
Group:          Development/Java
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
Requires:       logback-parent = %{epoch}:%{version}-%{release}
Requires:       logback-core = %{epoch}:%{version}-%{release}
BuildRequires:  tomcat7-catalina >= 0:7.0.21
# FIXME:
BuildRequires:  tomcat7-repolib >= 0:7.0.21
BuildRequires:  jboss-servlet-api_2.5_spec >= 0:1.0.1
BuildRequires:  janino >= 0:2.6.1
BuildRequires:  hsqldb >= 0:1.8.0.7
# FIXME: mail >= 0:1.4
BuildRequires:  glassfish-javamail >= 0:1.4
BuildRequires:  maven-surefire-plugin >= 0:2.14.1
BuildRequires:  maven-jar-plugin >= 0:2.3.1
BuildRequires:  maven-bundle-plugin

%description -n logback-access
logback-access module.

%package -n logback-site
Summary:        Logback Site
Group:          Development/Java
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
Requires:       logback-parent = %{epoch}:%{version}-%{release}
BuildRequires:  maven-site-plugin

%description -n logback-site
logback-site module.

%package -n logback-examples
Summary:        Logback Examples Module
Group:          Development/Java
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
Requires:       logback-parent = %{epoch}:%{version}-%{release}
Requires:       logback-core = %{epoch}:%{version}-%{release}
Requires:       logback-classic = %{epoch}:%{version}-%{release}
Requires:       logback-access = %{epoch}:%{version}-%{release}
Requires:       slf4j-ext >= 0:1.7.5
BuildRequires:  slf4j-ext >= 0:1.7.5
Requires:       log4j >= 0:1.2.14
BuildRequires:  log4j >= 0:1.2.14
BuildRequires:  jboss-servlet-api_2.5_spec >= 0:1.0.1
BuildRequires:  jansi >= 0:1.9
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-antrun-plugin

%description -n logback-examples
logback-examples module.

%package -n logback-javadoc
Summary:        Javadoc for logback-parent
Group:          Development/Documentation
Requires:       jpackage-utils
BuildRequires:  jpackage-utils

%description -n logback-javadoc
%{summary}.

%package -n logback-site-site
Summary:        Site for logback-parent
Group:          Development/Documentation
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
Requires:       logback-javadoc = %{epoch}:%{version}-%{release}

%description -n logback-site-site
%{summary}.

%prep
%setup -q -n logback-%{namedversion}
%patch0 -p1 -b .0000~
%patch1 -p1 -b .0001~
%patch2 -p1 -b .0002~
%patch3 -p1 -b .0003~

%{__rm} -r logback-access/src/main/java/ch/qos/logback/access/jetty/
%{__rm} -r logback-access/src/test/java/

pushd logback-classic/src/test/java
%{__tar} xf %{SOURCE1}
popd

TOMCAT_CATALINA_PKG_NAME=`/bin/rpm -q --whatprovides tomcat7-catalina 2>/dev/null`
[ -n "${TOMCAT_CATALINA_PKG_NAME}" ] || exit 1
TOMCAT_VERSION=`/bin/rpm -q --queryformat "%{VERSION}\n" ${TOMCAT_CATALINA_PKG_NAME} 2>/dev/null`
[ -n "${TOMCAT_VERSION}" ] || exit 1
%{__perl} -pi -e "s|<tomcat.version>.*</tomcat.version>|<tomcat.version>${TOMCAT_VERSION}</tomcat.version>|;" pom.xml

# FIXME:
export MAVEN_REPO_LOCAL=${PWD}/.m2/repository
%{__mkdir_p} ${MAVEN_REPO_LOCAL}
pushd %{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr * ${MAVEN_REPO_LOCAL}
popd

%build
export MAVEN_REPO_LOCAL=${PWD}/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=remote-repository::default::file://${PWD}/maven2-brew
export MAVEN_OPTS=
%{_bindir}/mvn-jpp -B -C -e -U -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -DperformRelease -Dmaven.test.skip -Dslf4jJAR=%{_javadir}/slf4j-api.jar deploy javadoc:aggregate site

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p maven2-brew/ch/qos/logback/logback-core/%{namedversion}/logback-core-%{namedversion}.jar %{buildroot}%{_javadir}/logback-core-%{namedversion}.jar
%{__cp} -p maven2-brew/ch/qos/logback/logback-core/%{namedversion}/logback-core-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/logback-core-%{namedversion}-javadoc.jar
%{__cp} -p maven2-brew/ch/qos/logback/logback-core/%{namedversion}/logback-core-%{namedversion}-sources.jar %{buildroot}%{_javadir}/logback-core-%{namedversion}-sources.jar
%{__cp} -p maven2-brew/ch/qos/logback/logback-classic/%{namedversion}/logback-classic-%{namedversion}.jar %{buildroot}%{_javadir}/logback-classic-%{namedversion}.jar
%{__cp} -p maven2-brew/ch/qos/logback/logback-classic/%{namedversion}/logback-classic-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/logback-classic-%{namedversion}-javadoc.jar
%{__cp} -p maven2-brew/ch/qos/logback/logback-classic/%{namedversion}/logback-classic-%{namedversion}-sources.jar %{buildroot}%{_javadir}/logback-classic-%{namedversion}-sources.jar
%{__cp} -p maven2-brew/ch/qos/logback/logback-access/%{namedversion}/logback-access-%{namedversion}.jar %{buildroot}%{_javadir}/logback-access-%{namedversion}.jar
%{__cp} -p maven2-brew/ch/qos/logback/logback-access/%{namedversion}/logback-access-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/logback-access-%{namedversion}-javadoc.jar
%{__cp} -p maven2-brew/ch/qos/logback/logback-access/%{namedversion}/logback-access-%{namedversion}-sources.jar %{buildroot}%{_javadir}/logback-access-%{namedversion}-sources.jar
%{__cp} -p maven2-brew/ch/qos/logback/logback-site/%{namedversion}/logback-site-%{namedversion}.jar %{buildroot}%{_javadir}/logback-site-%{namedversion}.jar
%{__cp} -p maven2-brew/ch/qos/logback/logback-site/%{namedversion}/logback-site-%{namedversion}-sources.jar %{buildroot}%{_javadir}/logback-site-%{namedversion}-sources.jar
%{__cp} -p maven2-brew/ch/qos/logback/logback-examples/%{namedversion}/logback-examples-%{namedversion}.jar %{buildroot}%{_javadir}/logback-examples-%{namedversion}.jar
%{__cp} -p maven2-brew/ch/qos/logback/logback-examples/%{namedversion}/logback-examples-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/logback-examples-%{namedversion}-javadoc.jar
%{__cp} -p maven2-brew/ch/qos/logback/logback-examples/%{namedversion}/logback-examples-%{namedversion}-sources.jar %{buildroot}%{_javadir}/logback-examples-%{namedversion}-sources.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%{__cp} -p maven2-brew/ch/qos/logback/logback-parent/%{namedversion}/logback-parent-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-logback-parent.pom
%{__cp} -p maven2-brew/ch/qos/logback/logback-core/%{namedversion}/logback-core-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-logback-core.pom
%{__cp} -p maven2-brew/ch/qos/logback/logback-classic/%{namedversion}/logback-classic-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-logback-classic.pom
%{__cp} -p maven2-brew/ch/qos/logback/logback-access/%{namedversion}/logback-access-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-logback-access.pom
%{__cp} -p maven2-brew/ch/qos/logback/logback-site/%{namedversion}/logback-site-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-logback-site.pom
%{__cp} -p maven2-brew/ch/qos/logback/logback-examples/%{namedversion}/logback-examples-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-logback-examples.pom

# depmaps
%add_to_maven_depmap ch.qos.logback logback-parent %{namedversion} JPP logback-parent
[ %{name} = "logback-parent" ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/logback-parent
%add_to_maven_depmap ch.qos.logback logback-core %{namedversion} JPP logback-core
[ %{name} = "logback-core" ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/logback-core
%add_to_maven_depmap ch.qos.logback logback-classic %{namedversion} JPP logback-classic
[ %{name} = "logback-classic" ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/logback-classic
%add_to_maven_depmap ch.qos.logback logback-access %{namedversion} JPP logback-access
[ %{name} = "logback-access" ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/logback-access
%add_to_maven_depmap ch.qos.logback logback-site %{namedversion} JPP logback-site
[ %{name} = "logback-site" ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/logback-site
%add_to_maven_depmap ch.qos.logback logback-examples %{namedversion} JPP logback-examples
[ %{name} = "logback-examples" ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/logback-examples

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/logback-%{namedversion}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/logback-%{namedversion}
%{__ln_s} logback-%{namedversion} %{buildroot}%{_javadocdir}/logback

# site
%{__mkdir_p} %{buildroot}%{_docdir}/logback-site-%{namedversion}
%{__cp} -pr target/site/* %{buildroot}%{_docdir}/logback-site-%{namedversion}
%{__rm} -r %{buildroot}%{_docdir}/logback-site-%{namedversion}/apidocs
%{__ln_s} %{_javadocdir}/logback %{buildroot}%{_docdir}/logback-site-%{namedversion}/apidocs
%{__ln_s} logback-site-%{namedversion} %{buildroot}%{_docdir}/logback-site

%clean
%{__rm} -rf %{buildroot}

%post -n logback-parent
%update_maven_depmap

%postun -n logback-parent
%update_maven_depmap

%post -n logback-core
%update_maven_depmap

%postun -n logback-core
%update_maven_depmap

%post -n logback-classic
%update_maven_depmap

%postun -n logback-classic
%update_maven_depmap

%post -n logback-access
%update_maven_depmap

%postun -n logback-access
%update_maven_depmap

%post -n logback-site
%update_maven_depmap

%postun -n logback-site
%update_maven_depmap

%post -n logback-examples
%update_maven_depmap

%postun -n logback-examples
%update_maven_depmap

%files
%defattr(0644,root,root,0755)

%files -n logback-parent
%defattr(0644,root,root,0755)
%{_mavenpomdir}/JPP-logback-parent.pom
%{_mavendepmapfragdir}/logback-parent

%files -n logback-core
%defattr(0644,root,root,0755)
%{_javadir}/logback-core-%{namedversion}.jar
%{_javadir}/logback-core.jar
%{_javadir}/logback-core-%{namedversion}-javadoc.jar
%{_javadir}/logback-core-javadoc.jar
%{_javadir}/logback-core-%{namedversion}-sources.jar
%{_javadir}/logback-core-sources.jar
%{_mavenpomdir}/JPP-logback-core.pom
%{_mavendepmapfragdir}/logback-core

%files -n logback-classic
%defattr(0644,root,root,0755)
%{_javadir}/logback-classic-%{namedversion}.jar
%{_javadir}/logback-classic.jar
%{_javadir}/logback-classic-%{namedversion}-javadoc.jar
%{_javadir}/logback-classic-javadoc.jar
%{_javadir}/logback-classic-%{namedversion}-sources.jar
%{_javadir}/logback-classic-sources.jar
%{_mavenpomdir}/JPP-logback-classic.pom
%{_mavendepmapfragdir}/logback-classic

%files -n logback-access
%defattr(0644,root,root,0755)
%{_javadir}/logback-access-%{namedversion}.jar
%{_javadir}/logback-access.jar
%{_javadir}/logback-access-%{namedversion}-javadoc.jar
%{_javadir}/logback-access-javadoc.jar
%{_javadir}/logback-access-%{namedversion}-sources.jar
%{_javadir}/logback-access-sources.jar
%{_mavenpomdir}/JPP-logback-access.pom
%{_mavendepmapfragdir}/logback-access

%files -n logback-site
%defattr(0644,root,root,0755)
%{_javadir}/logback-site-%{namedversion}.jar
%{_javadir}/logback-site.jar
%{_javadir}/logback-site-%{namedversion}-sources.jar
%{_javadir}/logback-site-sources.jar
%{_mavenpomdir}/JPP-logback-site.pom
%{_mavendepmapfragdir}/logback-site

%files -n logback-examples
%defattr(0644,root,root,0755)
%{_javadir}/logback-examples-%{namedversion}.jar
%{_javadir}/logback-examples.jar
%{_javadir}/logback-examples-%{namedversion}-javadoc.jar
%{_javadir}/logback-examples-javadoc.jar
%{_javadir}/logback-examples-%{namedversion}-sources.jar
%{_javadir}/logback-examples-sources.jar
%{_mavenpomdir}/JPP-logback-examples.pom
%{_mavendepmapfragdir}/logback-examples

%files -n logback-javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/logback-%{namedversion}
%{_javadocdir}/logback

%files -n logback-site-site
%defattr(0644,root,root,0755)
%{_docdir}/logback-site-%{namedversion}
%{_docdir}/logback-site

%changelog
* Tue Mar 18 2014 David Walluck <dwalluck@redhat.com> 0:1.0.13-4
- insert the tomcat version used to build into pom.xml

* Tue Nov 26 2013 David Walluck <dwalluck@redhat.com> 0:1.0.13-3
- add main package for compat

* Mon Nov 25 2013 David Walluck <dwalluck@redhat.com> 0:1.0.13-2
- reduce pom patch

* Thu May 16 2013 David Walluck <dwalluck@redhat.com> 0:1.0.13-1
- 1.0.13

* Fri Apr 26 2013 David Walluck <dwalluck@redhat.com> 0:1.0.12-1
- 1.0.12

* Wed Apr 10 2013 David Walluck <dwalluck@redhat.com> 0:1.0.11-1
- 1.0.11

* Tue Dec 18 2012 David Walluck <dwalluck@redhat.com> 0:1.0.9-1
- release
